program FRAKTAL_beide; {$R-,S-,N-,E-}

uses crt,dos,vga13,graph;

label untbr;

var  br,er,bi,ei,si,sr,ci,cr,zi,zr,zia,zra,iq,rq,hr,hi,it,v,min:real;
     brs,ers,bis,eis,crs,cis,its,vs:string;
     GraphDriver,GraphMode,GraphError,l,lx,ly,lt:integer;
     lt1,lt2:longint;
     f,fraktnr,karte,aufl:byte;
     c,p_opt:char;
     pal:paltyp;

procedure pushpal(var pal:paltyp);

  var r,g,b,l:word;

  begin
    readpal(pal);
    r:=pal[384];
    g:=pal[385];
    b:=pal[386];
    for l:=128 to 255 do begin
      pal[l*3  ]:=pal[l*3+3];
      pal[l*3+1]:=pal[l*3+4];
      pal[l*3+2]:=pal[l*3+5];
    end;
    pal[765]:=r;
    pal[766]:=g;
    pal[767]:=b;
    setpal(pal)
  end;

procedure rainbow;
  var l:integer;
      p:real;

  begin
    readpal(pal);
    pal[0]:=3;
    pal[1]:=3;
    pal[2]:=3;
    for l:=128 to 255 do begin
      p:=sin((l-128)*pi/64);
      p:=p*p*p;
      pal[l*3  ]:=trunc(cos((l-128-8   )*pi/64)*16+16+(p*16+16));
      pal[l*3+1]:=trunc(cos((l-128-8-42)*pi/64)*16+16+(p*16+16));
      pal[l*3+2]:=trunc(cos((l-128-8-85)*pi/64)*16+16+(p*16+16))
    end;
    setpal(pal)
  end;

procedure grey;
  var l:integer;

  begin
    readpal(pal);
    for l:=1 to 64 do begin
      pal[383+l*3  ]:=pred(l);
      pal[383+l*3+1]:=pred(l);
      pal[383+l*3+2]:=pred(l);
      pal[770-l*3  ]:=pred(l);
      pal[770-l*3+1]:=pred(l);
      pal[770-l*3+2]:=pred(l)
    end;
    setpal(pal)
  end;

procedure input(var wert:real);

  const blank='                ';

  var xold,yold:byte;
      inf      :integer;
      st       :string;

  begin
    xold:=wherex;
    yold:=wherey;
    repeat
      readln(st);
      if st<>'' then val(st,wert,inf)
                else inf:=0;
      if inf<>0 then begin
        gotoxy(xold,yold);
        write(blank);
        gotoxy(xold,yold)
      end
    until inf=0
  end;

procedure selectchip;

  begin
    clrscr;
    textcolor(lightred);
    gotoxy(36,2);
    writeln('FRAKTALE');
    writeln;
    textcolor(lightgreen);
    writeln;
    writeln('  Untersttzt werden folgende SuperVGA-Karten :');
    writeln;
    writeln('     0 =  jede VGA-Karte ab 256 KByte (bis  640*400 ?)');
    writeln('     1 =  Tseng  ET3000 bis 512 KByte (bis  800*600)');
    writeln('     2 =  Tseng  ET4000 bis   1 MByte (bis 1024*768)');
    writeln('     3 =  Paradise      bis 512 KByte (bis  640*480)');
    writeln('     4 =  Video Seven   bis 512 KByte (bis  640*480)');
    writeln('     5 =  Trident       bis 512 KByte (bis  800*600)');
    writeln;
    writeln('  Whlen Sie 0, wenn Sie den Chipsatz Ihrer Grafikkarte nicht kennen.');
    writeln('  Dann er wird durch Abfrage des Video-BIOS automatisch ermittelt.');
    writeln('  Sollte dies nicht funktionieren, probieren Sie den direkten Aufruf');
    writeln('  oder behalten Sie stets Karte [0] und Auflsung [0] (320*200).');
    writeln;
    write('  Gewhlter Chipsatz : ');
    repeat c:=readkey until c in ['0'..'5'];
    val(c,karte,l);
    writeln(c);
    if karte=0 then begin
      writeln;
      write('  Zu hoch gewhlte Auflsungen werden sicher meist reduziert.');
      c:=readkey
    end;
    delay(50)
  end;

procedure titel;

  begin
    clrscr;
    textcolor(lightred);
    gotoxy(36,6);
    writeln('FRAKTALE');
    writeln;
    textcolor(lightgreen);
    writeln('  Folgende Fraktale stehen zur Auswahl:');
    writeln;
    writeln('    [1] Apfelmnnchen (Mandelbrodtmenge)');
    writeln('    [2] Julia-Menge');
    writeln('    [3] Explosion');
    writeln;
    write('  Welches wollen Sie betrachten ? ');
    repeat c:=readkey until c in ['1'..'3'];
    val(c,fraktnr,l);
    writeln(c);
    delay(50)
  end;

procedure apfel;
  begin
    ci:=ei-si*ly*v;
    cr:=br+sr*lx*v;
      zi:=ci;zr:=cr;
      iq:=zi*zi;rq:=zr*zr;
      lt:=0;
      repeat
        zia:=zi;
        zra:=zr;
        zi:=2*zi*zr+ci ;
        zr:=rq-iq+cr ;
          iq:=zi*zi;
          rq:=zr*zr ;
          inc(lt)
      until (lt>it) or (rq+iq>4) or (abs(zia-zi)<1e-3) or (abs(zra-zr)<1e-3);
      f:=(trunc(abs(rq-iq)) mod 128 )
    end;

procedure julia;
  begin
    zi:=ei-si*ly*v;
    zr:=br+sr*lx*v;
      iq:=zi*zi;rq:=zr*zr;
      lt:=0;
      repeat
      zi:=2*zi*zr+ci ;
        zr:=rq-iq+ci ;
          iq:=zi*zi;
          rq:=zr*zr ;
          inc(lt)
      until (lt>it) or (rq+iq>4) or (abs(zia-zi)<1e-3) or (abs(zra-zr)<1e-3);
      f:=(trunc(abs(rq-iq)) mod 128 )
    end;

procedure explosion;
  begin
    ci:=ei-si*ly*v;
    cr:=br+sr*lx*v;
    zi:=ci;zr:=cr;
    iq:=zi*zi;rq:=zr*zr;
    lt:=0;
    repeat
      zia:=zi;
      zra:=zr;
      zi:=cr*zi+2*cr*zr*zi+zr*ci+zr*zr*ci-zi*zi*ci;
      zr:=zr*cr+zr*zr*cr-zi*zi*cr-ci*zi-2*zr*zi*ci;
      iq:=zi*zi+zi;
      rq:=zr*zr+zr;
      inc(lt)
    until (lt>it) or (rq+iq>4) or (abs(zia-zi)<1e-3) or (abs(zra-zr)<1e-3);
    hr:=rq+iq;
    hi:=int(hr/32768);
    if hi > 0 then hr:=hr/hi;
    f:=trunc(hr) mod 128
  end;
{---------------------------------------------------------------------------}

begin
  checkbreak:=true;
  setcbreak(true);
  GraphDriver:=InstallUserDriver('SUPERVGA.BGI',NIL);
  textmode(CO80);
  textbackground(blue);
  br:=-3;str(br,brs);
  bi:=-3;str(bi,bis);
  er:=3;str(er,ers);
  ei:=3;str(ei,eis);
  cr:=0.3;str(cr,crs);
  ci:=0.3;str(ci,cis);
  it:=10;str(it,its);
  v:=4;str(v,vs);
  selectchip;
  titel;
  repeat
    clrscr;
    textcolor(lightred);
    gotoxy(36,2);
    writeln('FRAKTALE');
    writeln;
    textcolor(lightgreen);
    writeln('  Sie whlen einen Ausschnitt');
    write('  entlang der Realachse von links (',br:7:4,') ');input(br);
    write('  bis rechts (',er:7:4,') ');input(er);
    write('  und entlang der Imaginrachse von unten (',bi:7:4,') ');input(bi);
    write('  bis oben (',ei:7:4,') ');input(ei);
    write('  Die Iterationstiefe betrage (',it:5:0,') ');input(it);
    write('  Das Bild wird verkleinert auf (1/',v:7:3,') 1/');input(v);
    if fraktnr=2 then begin
      write('  Die Realkonstante betrgt (',cr:7:4,') ');input(cr);
      write('  und die Imaginrkonstante (',ci:7:4,') ');input(ci)
    end;
    writeln;
    write('  Wnschen Sie optimierte Farbpalette (J/N) ? ');
    repeat p_opt:=upcase(readkey) until p_opt in ['J','N'];
    writeln(p_opt);
    if upcase(p_opt)='J' then begin
      write('    (R)egenbogen oder (G)raustufen ? ');
      repeat p_opt:=upcase(readkey) until p_opt in ['R','G'];
      writeln(p_opt)
    end;
    writeln;
    writeln('     0 =  320*200 (prinzipiell jede VGA-Karte)');
    writeln('     1 =  640*350 (wahrscheinlich jede VGA-Karte)');
    writeln('     2 =  640*400 (wahrscheinlich jede VGA-Karte)');
    writeln('     3 =  640*480 (jede SuperVGA-Karte ab 512 KByte)');
    writeln('     4 =  800*600 (jede SuperVGA-Karte ab 512 KByte)');
    writeln('     5 = 1024*768 (SuperVGA-Karte mit 1 MByte und MultiSync-Monitor)');
    writeln;
    write('  Whlen Sie die Auflsung : ');
    repeat c:=readkey until c in ['0'..'5'];
    val(c,aufl,l);
    writeln(c);
    if aufl=0 then GraphMode:=0
              else GraphMode:=5*karte+aufl;
    InitGraph(GraphDriver,GraphMode,'');
    GraphError:=GraphResult;
    if GraphError <> grOk then begin
      CloseGraph;
      writeln;
      writeln(GraphErrorMsg(GraphError));
      halt(1)
    end;
    clearviewport;
    case upcase(p_opt) of 'R' : rainbow;
                          'G' : grey
    end;
    si:=(ei-bi)/GetMaxY;
    sr:=(er-br)/GetMaxX;
    setfillstyle(solidfill,white);
    bar((GetMaxX div 2)-(trunc(GetMaxX/(2*v))),
        (GetMaxY div 2)-(trunc(GetMaxY/(2*v))),
         succ((GetMaxX div 2)+(trunc(GetMaxX/(2*v)))),
         succ((GetMaxY div 2)+(trunc(GetMaxY/(2*v)))));
    setfillstyle(solidfill,lightgray);
    bar(succ((GetMaxX div 2)-(trunc(GetMaxX/(2*v)))),
        succ((GetMaxY div 2)-(trunc(GetMaxY/(2*v)))),
        (GetMaxX div 2)+(trunc(GetMaxX/(2*v))),
        (GetMaxY div 2)+(trunc(GetMaxY/(2*v))));
    for ly:=1 to pred(trunc(GetMaxY/v)) do begin
      for lx:=1 to pred(trunc(GetMaxX/v)) do begin
        case fraktnr of 1:apfel;
                        2:julia;
                        3:explosion;
        end;
        if lt>=it then f:=darkgray
                  else f:=128+((2*pred(lt)+f) mod 128);
        putpixel((GetMaxX div 2)-(trunc(GetMaxX/(2*v)))+lx,
                 (GetMaxY div 2)-(trunc(GetMaxY/(2*v)))+ly,
                  f);
        if keypressed and (readkey=#27) then goto untbr
      end;
      pushpal(pal);
    end;
    write(#7);
    repeat
      repeat
        delay(100);
        pushpal(pal)
      until keypressed;
    until readkey in [#13,#27];
untbr:
    closegraph;
    textmode(CO80);
    textbackground(blue);
    textcolor(lightgreen);
    clrscr;
    writeln;
    writeln('  Real      : ',br:12:8,' ... ',er:12:8);
    writeln('  Imaginr  : ',bi:12:8,' ... ',ei:12:8);
    if fraktnr=2 then
    writeln('  Konstanten: ',cr:12:8,'  ;  ',ci:12:8);
    writeln('  It.-tiefe : ',it:5:0);
    writeln;
    write('  Noch eine Darstellung (J/N) ? ');
    repeat c:=upcase(readkey) until c in ['J','N'];
    writeln(c);
    if upcase(c)='J' then begin
      writeln;
      write('  Wollen Sie den gleichen Chipsatz wieder nutzen (J/N) ? ');
      repeat c:=upcase(readkey) until c in ['J','N'];
      writeln(c);
      if c='N' then begin
        selectchip;
        clrscr
      end;
      writeln;
      write('  Wollen Sie das gleiche Fraktal wieder darstellen lassen (J/N) ? ');
      repeat c:=upcase(readkey) until c in ['J','N'];
      writeln(c);
      if c='N' then titel
    end
  until upcase(c)='N';
  textcolor(lightgray);
  textbackground(black);
  clrscr
end.
